<?php

/**

 * @package Admin

 * @todo    Services page for WHMpress admin panel

 */



if ( ! defined( 'WHMP_VERSION' ) ) {

    wp_die("Direct acces not allowed by WHMPress", "Forbidden");

}



global $wpdb;

if (isset($_GET["del-group"])) whmp_delete_group($_GET["del-group"]);

 ?>



<div class="wrap">

    <div class="whmp-main-title"><span class="whmp-title">WHMpress</span> <?php _e("Pricing Table Groups", "whmpress") ?></div>    

    <?php

    if (isset($_POST["id"])) {

        $data["name"] = @$_POST["name"];

        $data["rows"] = @$_POST["rows"];

        $data["currency"] = @$_POST["currency"];

        $data["color"] = @$_POST["color"];

        $data["ribbon_text"] = @$_POST["ribbon_text"];

        $data["billingcycle"] = @$_POST["billingcycle"];

        $data["html_id"] = @$_POST["html_id"];

        $data["html_class"] = @$_POST["html_class"];

        $data["decimals"] = @$_POST["decimals"];

        $data["decimals_tag"] = @$_POST["decimals_tag"];

        $data["hide_decimal"] = @$_POST["hide_decimal"];

        $data["prefix"] = @$_POST["prefix"];

        $data["suffix"] = @$_POST["suffix"];

        $data["show_duration"] = @$_POST["show_duration"];

        $data["description"] = @$_POST["description"];

        $data["show_duration_as"] = @$_POST["show_duration_as"];

        $data["convert_monthly"] = @$_POST["convert_monthly"];

        $data["alternate_rows"] = @$_POST["alternate_rows"];

        $data["button_text"] = @$_POST["button_text"];

        $data["template_file"] = @$_POST["template_file"];

        

        if (empty($_POST["id"])) {

            $response = $wpdb->insert( whmp_get_group_table_name(), $data );

        } else {

            $response = $wpdb->update( whmp_get_group_table_name(), $data, array("id"=>@$_POST["id"]) );

        }

        

    }

        

    if (isset($_GET["add"])): require_once WHMP_ADMIN_DIR."/groups/group-add.php";

    elseif (isset($_GET["edit"])): require_once WHMP_ADMIN_DIR."/groups/group-edit.php";

    elseif (isset($_GET["plans"])): require_once WHMP_ADMIN_DIR."/groups/group-plans.php";

    else:

        $Q = "SELECT * FROM `".whmp_get_group_table_name()."`";

        $groups = $wpdb->get_results($Q,ARRAY_A);

        

        if (!isset($_GET["add"]) && !isset($_GET["edit"])) { ?>

        <a href="?page=whmp-groups&add" class="button button-primary">Add Group</a>

        <?php } ?>

        

        <div class="updated">

            <p>

            On this page you can create a Group of Pricing Tables and then use the corresponding ShortCode to display them on your pages. After creating group, use "Select Plans" to add remove Plans/Packages and "Settings" to change all other settings.

            </p>

        </div>

        

        <table class="fancy" style="width:100%">

            <thead>

                <tr class="mytr">

                    <th style="width:25px">ID</th>

                    <th style="width:30%">Group Name</th>

                    <th>Plans</th>

                    <th>Code</th>

                    <th></th>

                    <th style="width: 10px;"></th>

                </tr>

            </thead>

            <tbody>

                <?php

                if (is_array($groups) && sizeof($groups)>0)

                foreach($groups as $group):

                $code = '[whmpress_price_table_group id="'.$group["id"].'"]';

                 ?>

                <tr>

                    <td><?php echo $group["id"] ?></td>

                    <td><a href="?page=whmp-groups&edit=<?php echo $group["id"] ?>"><?php echo $group["name"] ?></a></td>

                    <td><?php echo $wpdb->get_var("SELECT COUNT(*) FROM `".whmp_get_group_detail_table_name()."` WHERE `group_id`=".$group["id"]); ?></td>

                    <!--td><input style="width:100%;background-color:#FFFFFF" class="select_me" type="text" value='<?php echo $code ?>' readonly="readonly" /></td-->

                    

                    <td><a class="button" href="?page=whmp-groups&plans=<?php echo $group["id"] ?>">Select Plans</a>

                    <a class="button" href="?page=whmp-groups&edit=<?php echo $group["id"] ?>">Settings</a>

                    </td>

                    <td><a title="Delete this group" data-id="<?php echo $group["id"] ?>" href="admin.php?page=whmp-groups&del-group=<?php echo $group["id"] ?>" class="del-button"><span class="dashicons dashicons-trash"></span></a></td>

                </tr>

                <?php endforeach;

                else { ?>

                    <tr>

                        <td colspan="4" style="text-align: center;"><em>No group found - <a href="?page=whmp-groups&add">Add new group</a></em></td>

                    </tr>

                <?php } ?>

            </tbody>

        </table>

    <?php endif; ?>

</div>



<script>

jQuery(function(){

    jQuery(".del-button").click(function(event){

        //event.preventDefault();

        

        if (!confirm("Are you sure you want to delete this group?")) return false;

    });

    jQuery(".select_me").focus(function(){

        jQuery(this).select();

    });

});

</script>